from typing import List, Optional

from pymemri.data.itembase import Item
from pymemri.data.schema import Label, Message


class Message(Item):
    edges = Item.edges + ["prediction"]
    properties = Item.properties + ["content"]

    def __init__(self, content: str = None, **kwargs):
        super().__init__(**kwargs)
        self.content = content
        self.prediction = []

class CategoricalPrediction(Item):
    properties = Item.properties + ["name", "probs", "labels"]

    def __init__(
        self,
        probs: str = None,
        labels: str = None,
        name: str = None,
        **kwargs
    ):
        super().__init__(**kwargs)
        self.name = name
        self.probs = probs
        self.labels = labels


class CategoricalLabel(Item):
    properties = Item.properties + ["name", "index", "names"]

    def __init__(
        self, name: str = None, index: int = None, names: str = None, **kwargs
    ):
        super().__init__(**kwargs)
        self.name: Optional[str] = name
        self.index: Optional[str] = index
        self.names: Optional[str] = names
